clear all; close all;
%
T=1024*4; K=200; N=1000;
% noises
KrOut=0.0; KrIn=0.5;
% regularization constant
lamb=1000;
%- impulse input -------
u0=[100; zeros(T-1,1)];
%------------------------
[bcoeff,acoeff]=butter(1,0.01); 
y0=filter(bcoeff,acoeff,u0); 
figure(1), subplot(211), plot(u0(1:K)); grid; title('Input');
subplot(212), stem(y0(1:K)); grid; title('Output');

%-noisy inoput measurement ------------
um=u0+KrIn*randn(size(u0));
%- measurement matrix ----------
u=um(1:N); ur=[um(1) zeros(1,K)]; 
H=toeplitz(u,ur);
%- unit matrix for regularization -------------
EE=lamb*eye(1+K);
%-- noisy output measurement -------------
ym=y0+KrOut*randn(size(y0));
y1=y0(1:N); y2=ym(1:N);
%-- estimates --------------------
gpls=inv(H'*H)*H'*y1; 
gnls=inv(H'*H)*H'*y2; 
gnlsr=inv(H'*H+EE)*H'*y2;
%-------------------------------
figure(3), stem(gpls,'k'); grid; hold on;  
stem(gnls,'r'); stem(gnlsr,'g'); hold off;
title('k - LS, r - noisy LS, g - regularized'); 
%--------------------------




